unit CHILDWIN;

interface

uses Windows, Classes, Graphics, Forms, Controls, StdCtrls, ExtCtrls,SysUtils,
     messages,UOOAPanel, Menus, Buttons, ComCtrls, ImgList;
type
  TMDIChild = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    ScrollBox1: TScrollBox;
    OOAPanel1: TOOAPanel;
    Panel1: TPanel;
    Label1: TLabel;
    OOPager: TComboBox;
    ImageList1: TImageList;
    ImageList2: TImageList;
    Panel2: TPanel;
    Label2: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    EdCurrentCtrl: TEdit;
    ImageList3: TImageList;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ScrollBox1MouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure ScrollBox1MouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure OOPagerDropDown(Sender: TObject);
    procedure OOPagerChange(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure OOAPanel1SelectCtrl(Sender: TOOAPanel; OldCtrl,
      NewCtrl: TControl);
  private
    { Private declarations }
    ActiveCtrl:TWinControl;
    procedure getmouse(var msg:TWMMouseWheel);message WM_MouseWheel;
  public
    { Public declarations }
  end;

implementation

{$R *.dfm}

procedure TMDIChild.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TMDIChild.getmouse(var msg: TWMMouseWheel);
begin
  case PageControl1.ActivePageIndex of
    0:ScrollBox1.SetFocus;
  end;//case...end!!  
end;

procedure TMDIChild.ScrollBox1MouseWheelUp(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
var posi:integer;
begin
  posi := ScrollBox1.VertScrollBar.Position - 25;
  if(ScrollBox1.VertScrollBar.Position < 0)then posi := 0;
  ScrollBox1.VertScrollBar.Position := posi;
end;

procedure TMDIChild.ScrollBox1MouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
  ScrollBox1.VertScrollBar.Position := ScrollBox1.VertScrollBar.Position+25;
end;

procedure TMDIChild.OOPagerDropDown(Sender: TObject);
begin
  OOPager.Items.Clear;
  OOPager.Items.Text := self.OOAPanel1.GetAllPageName;
end;

procedure TMDIChild.OOPagerChange(Sender: TObject);
begin
  if(self.OOAPanel1.ActivePageName = OOPager.Text)then
    begin
      self.ScrollBox1.SetFocus;
      Exit;
    end;//if...end!!
  //---------------------------------------------------
  self.OOAPanel1.ActivePageName := OOPager.Text;
  self.OOAPanel1.RefreshPopMenuCaptions;
  self.OOAPanel1.RefreshPageObjects;
  self.ScrollBox1.SetFocus;
end;

procedure TMDIChild.SpeedButton1Click(Sender: TObject);
begin
  OOAPanel1.SelectedCtrl.Left := OOAPanel1.SelectedCtrl.Left -1;
  if(OOAPanel1.SelectedCtrl.ClassType = TEntity)then
    TEntity(OOAPanel1.SelectedCtrl).RefreshAllObjectLinkPoints
  else
    if(OOAPanel1.SelectedCtrl.ClassType = TRelation)then
      TRelation(OOAPanel1.SelectedCtrl).UpdateSelfPositionInPage(OOAPanel1.ActivePageName)
    else
      if(OOAPanel1.SelectedCtrl.ClassType = TEntityEvent)then
        TEntityEvent(OOAPanel1.SelectedCtrl).UpdateSelfPositionInPage(OOAPanel1.ActivePageName);
  OOAPanel1.Invalidate;
end;

procedure TMDIChild.SpeedButton2Click(Sender: TObject);
begin
  OOAPanel1.SelectedCtrl.Top := OOAPanel1.SelectedCtrl.Top -1;
  if(OOAPanel1.SelectedCtrl.ClassType = TEntity)then
    TEntity(OOAPanel1.SelectedCtrl).RefreshAllObjectLinkPoints
  else
    if(OOAPanel1.SelectedCtrl.ClassType = TRelation)then
      TRelation(OOAPanel1.SelectedCtrl).UpdateSelfPositionInPage(OOAPanel1.ActivePageName)
    else
      if(OOAPanel1.SelectedCtrl.ClassType = TEntityEvent)then
        TEntityEvent(OOAPanel1.SelectedCtrl).UpdateSelfPositionInPage(OOAPanel1.ActivePageName);
  OOAPanel1.Invalidate;
end;

procedure TMDIChild.SpeedButton3Click(Sender: TObject);
begin
  OOAPanel1.SelectedCtrl.Top := OOAPanel1.SelectedCtrl.Top +1;
  if(OOAPanel1.SelectedCtrl.ClassType = TEntity)then
    TEntity(OOAPanel1.SelectedCtrl).RefreshAllObjectLinkPoints
  else
    if(OOAPanel1.SelectedCtrl.ClassType = TRelation)then
      TRelation(OOAPanel1.SelectedCtrl).UpdateSelfPositionInPage(OOAPanel1.ActivePageName)
    else
      if(OOAPanel1.SelectedCtrl.ClassType = TEntityEvent)then
        TEntityEvent(OOAPanel1.SelectedCtrl).UpdateSelfPositionInPage(OOAPanel1.ActivePageName);
  OOAPanel1.Invalidate;
end;

procedure TMDIChild.SpeedButton4Click(Sender: TObject);
begin
  OOAPanel1.SelectedCtrl.Left := OOAPanel1.SelectedCtrl.Left +1;
  if(OOAPanel1.SelectedCtrl.ClassType = TEntity)then
    TEntity(OOAPanel1.SelectedCtrl).RefreshAllObjectLinkPoints
  else
    if(OOAPanel1.SelectedCtrl.ClassType = TRelation)then
      TRelation(OOAPanel1.SelectedCtrl).UpdateSelfPositionInPage(OOAPanel1.ActivePageName)
    else
      if(OOAPanel1.SelectedCtrl.ClassType = TEntityEvent)then
        TEntityEvent(OOAPanel1.SelectedCtrl).UpdateSelfPositionInPage(OOAPanel1.ActivePageName);
  OOAPanel1.Invalidate;
end;

procedure TMDIChild.OOAPanel1SelectCtrl(Sender: TOOAPanel; OldCtrl,
  NewCtrl: TControl);
begin
  if(NewCtrl = nil)then EdCurrentCtrl.Text := ''
  else
    if(NewCtrl.ClassType = TEntity)then
      EdCurrentCtrl.Text := TEntity(NewCtrl).EntityDesc
    else
      if(NewCtrl.ClassType = TRelation)then
        EdCurrentCtrl.Text := TRelation(NewCtrl).RelationDesc
      else
        if(NewCtrl.ClassType = TEntityEvent)then
          EdCurrentCtrl.Text := TEntityEvent(NewCtrl).EventDesc;
end;


end.
